/* FILE: Rand48.cpp   last change: Feb 1998
 *
 * bucket[value][...] is an array (called bucket) containing
 * size[value] nodes with a given value
 * the pos of a given node in a given bucket is pos[node]
 */

#include "Buckets.H"


//  The constructor and destructor of class buckets.


Buckets::Buckets(int num_nodes, int my_max_value):
		max_value(my_max_value)
 {
     max = INT_MIN;  min = INT_MAX;
     pos = new ListPos [num_nodes +1];  // nodes range from 1 to "num_nodes".

     bucket = new List* [2*max_value +1];
     bucket += max_value;  // shift so that 
     // bucket[min_value] ... bucket[max_value] can be used.

     for(int i = -max_value; i <= max_value; i++)
        bucket[i] = new List;
 }


Buckets::~Buckets()
 {
     for(int i = -max_value; i <= max_value; i++)    delete bucket[i];

     delete []  (bucket - max_value);

     delete [] pos;
 }












